<template>
  <div class="tms-policy">
    <div
      v-if="tmsInfo"
      :class="[ 'badge', { 'compact-mode': isCompact } ]"
    >
      <i class="icon checked badge__icon" />

      <div :class="[ 'badge__text', { 'compact-mode': isCompact } ]">
        <span :class="[ 'badge__title', { 'compact-mode': isCompact } ]">
          Создана политика распределения

          <a
            :href="`/tms/${tmsInfo.tmsUuid}`"
            class="link-style"
            target="_blank"
          >
            {{ tmsInfo.title }}
          </a>
        </span>

        <div
          v-if="tmsInfo.totalLotErrors"
          class="badge__error"
        >
          Ошибок: {{ tmsInfo.totalLotErrors }},

          <a
            href="#"
            class="link-style"
            @click="openResultModal"
          >
            смотреть
          </a>
        </div>
      </div>
    </div>

    <ObButton
      v-else-if="tmsInfo !== null"
      :disabled="isPending"
      :mini="isCompact"
      @click="openInfoModal"
    >
      <div class="button-content">
        <div
          v-if="isPending"
          :class="[ 'button-loader', { 'compact': isCompact } ]"
        >
          <ObLoader
            :size="30"
            class="button-loader__inner"
          />
        </div>

        <div v-if="isPending">
          <span class="button-content__text">
            Идет создание политики распределения...
          </span>

          <div
            v-if="!isCompact && isLongPending"
            class="button-content__warning"
          >
            Это может занять до 5 мин
          </div>
        </div>

        <template v-else>
          Создать политику распределения
        </template>

        <i
          v-if="isPending"
          class="icon close cancel-button"
          @click.stop="cancelCreation"
        />
      </div>
    </ObButton>

    <ObModal
      ref="info-modal"
      size="md"
      title="Создание политики распределения"
      ok-text="Создать политику распределения"
      :is-show-controls="true"
      @submit="createTmsPolicy"
    >
      <div class="modal-description">
        Подготовка данных может занять до 5 минут.
        Вы можете закрыть вкладку браузера и вернуться,
        когда процесс будет завершен.
      </div>
    </ObModal>

    <ObModal
      v-if="tmsInfo"
      ref="result-modal"
      size="xl"
      title="Создание политики распределения"
      cancel-text="Закрыть"
      :is-show-controls="true"
      :is-read-only="true"
    >
      <div class="modal-description">
        Создана политика распределения

        <a
          :href="`/tms/${tmsInfo.tmsUuid}`"
          class="link-style"
          target="_blank"
        >
          {{ tmsInfo.title }}
        </a>
      </div>

      <ObTable
        :columns="columns"
        :items="tmsInfo.lots"
        :functional-panel="true"
        :is-functional-sort="false"
        :is-functional-group="false"
        :is-functional-filter="false"
        class="table"
      />
    </ObModal>

    <ObModal
      ref="offer-modal"
      size="md"
      ok-text="Узнать больше"
      cancel-text="Закрыть"
      :is-show-controls="true"
    >
      <template slot="title">
        <div class="offer-heading">
          Подключите <b>TMS Gruzi</b> — систему управления транспортными заказами
        </div>
      </template>

      <div class="offer-features">
        <ul class="offer-features__list">
          <li class="offer-feature">
            <i class="icon offer-feature__icon share" />

            <span class="offer-feature__text">
              Автоматизация распределения заказов среди перевозчиков
            </span>
          </li>

          <li class="offer-feature">
            <i class="icon offer-feature__icon document" />

            <span class="offer-feature__text">
              Фиксация и учет договорных условий
            </span>
          </li>
          <li class="offer-feature">
            <i class="icon offer-feature__icon route" />

            <span class="offer-feature__text short-block">
              Отслеживание  изменений статусов и событий каждого заказа
            </span>
          </li>
        </ul>

        <ul class="offer-features__list">
          <li class="offer-feature">
            <i class="icon offer-feature__icon auction" />

            <span class="offer-feature__text">
              Тендеры, Трекинг, Спот‑Аукционы — взаимодействие внутри единой экосистемы
            </span>
          </li>
          <li class="offer-feature">
            <i class="icon offer-feature__icon tune" />

            <span class="offer-feature__text">
              Настройка системы под конкретные задачи и интеграция с системой ERP-клиента
            </span>
          </li>
        </ul>
      </div>
    </ObModal>
  </div>
</template>

<script>
  import api from '@/api'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObLoader from 'common-components/src/obComponents/obLoader'
  import ObTable from 'common-components/src/obComponents/obTable'
  import moment from 'moment'

  export default {
    name: 'tender-scenario-tms-policy',
    components: {
      ObModal,
      ObButton,
      ObLoader,
      ObTable
    },
    data () {
      return {
        tmsInfo: null,
        isPending: false,
        longLoadingTimeout: null,
        isLongPending: false,
        requestSource: null
      }
    },
    props: {
      tender: {
        type: Object,
        required: true
      },
      isCompact: {
        type: Boolean,
        default: false
      }
    },
    computed: {
      columns () {
        return [
          {
            title: 'Откуда',
            headerHtml: () => `<div class="text-gray">Откуда</div>Опорный пункт`,
            html: ({ fromLocationTitle, status }) => this.parseColumnText(fromLocationTitle, status),
            key: 'fromLocationTitle'
          },
          {
            title: 'Куда',
            headerHtml: () => `<div class="text-gray">Куда</div>Опорный пункт`,
            html: ({ toLocationTitle, status }) => this.parseColumnText(toLocationTitle, status),
            key: 'toLocationTitle'
          },
          {
            title: 'Вместимость (Паллет)',
            html: ({ palletCapacity, status }) => this.parseColumnText(palletCapacity, status),
            key: 'palletCapacity'
          },
          {
            title: 'Грузоподъемность (Тонн)',
            html: ({ loadCapacity, status }) => this.parseColumnText(loadCapacity, status),
            key: 'loadCapacity'
          },
          {
            title: 'Кубатура (м.куб)',
            html: ({ cubature, status }) => this.parseColumnText(cubature, status),
            key: 'cubature'
          },
          {
            title: 'Ошибка распознавания',
            key: 'errorDescription',
            html: ({ errorDescription, status }) => {
              const ERRORS = {
                ERROR_FROM: 'Не распозналось “откуда”',
                ERROR_TO: 'Не распозналось “куда”',
                ERROR_SERVICE: 'Не распознался тип ТС',
                DUPLICATE_DIRECTION: 'Дубликат направления для ресурса'
              }

              return this.parseColumnText(ERRORS[errorDescription], status)
            }
          }
        ]
      }
    },
    async mounted () {
      await this.getTmsInfo()
    },
    methods: {
      async getTmsInfo () {
        try {
          this.tmsInfo = await api.tendersScenarios.getTmsPolicyInfo(this.tender.uuid)
        } catch (e) {
          this.$refs['offer-modal'].open()
        }
      },
      openInfoModal () {
        this.$refs['info-modal'].open()
      },
      async createTmsPolicy () {
        this.isPending = true

        this.$refs['info-modal'].close()

        this.longLoadingTimeout = setTimeout(() => {
          this.isLongPending = true
        }, 15000)

        try {
          const axios = await import('axios')
          const cancelToken = axios.CancelToken

          this.requestSource = cancelToken.source()

          await api.tendersScenarios.createTmsPolicy({
            tenderUuid: this.tender.uuid,
            title: this.tender.title,
            startContractD: moment(this.tender.startContractDt).format('YYYY-MM-DD'),
            endContractD: moment(this.tender.endContractDt).format('YYYY-MM-DD')
          }, {
            cancelToken: this.requestSource.token
          })

          await this.getTmsInfo()

          this.$notification({
            type: 'snackbars',
            message: `
              Создана политика распределения для тендера
              <a href="/tms/${this.tmsInfo.tmsUuid}" target="_blank" class="link-style">${this.tender.number}</a>
            `,
            timeout: 6000,
            onclick: {
              label: 'Смотреть',
              action: () => this.openResultModal()
            }
          })
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка создания политики распределения'
          })
        }

        clearTimeout(this.longLoadingTimeout)

        // Small timeout for a visual improvement
        setTimeout(() => {
          this.isPending = false
          this.isLongPending = false
        }, 700)
      },
      openResultModal () {
        this.$refs['result-modal'].open()
      },
      cancelCreation () {
        this.requestSource.cancel('Создание политики распределения отменено пользователем.')

        this.isPending = false
      },
      parseColumnText (title, isError = false) {
        let template = title || '—'

        if (isError) {
          template = `<span class="-light-raspberry-red">${template}</span>`
        }

        return template
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .badge {
    display: flex;

    &.compact-mode {
      align-items: center;
    }

    &__icon {
      font-size: 17px;
      margin-right: 6px;
      font-weight: bold;
    }

    .icon::before {
      color: $Green-700;
    }

    &__text {
      @include font-mixin(14px, 18px, 400, $green-800);

      display: flex;

      &:not(.compact-mode) {
        flex-direction: column;
        margin-bottom: -22px;
      }
    }

    &__title {
      &.compact-mode:not(:last-child) {
        margin-right: 15px;
      }

      &:not(.compact-mode):not(:last-child) {
        margin-bottom: 4px;
      }
    }

    &__error {
      color: $color-error;
      text-align: right;
    }
  }

  .button-content {
    display: grid;
    align-items: center;
    grid-auto-flow: column;
    grid-column-gap: 10px;
    text-align: left;

    &__text {
      @include font-mixin(14px, 18px, 400, $color-grey-label);
    }

    &__warning {
      @include font-mixin(12px, 12px, 400, $color-grey-span, 0.4px);
    }
  }
  
  .button-loader {
    --loader-size: 24;

    width: calc(var(--loader-size) * 1px);
    height: calc(var(--loader-size) * 1px);
    display: flex;
    align-items: center;
    justify-content: center;

    &.compact {
      --loader-size: 16;
    }

    &__inner {
      transform: scale(calc(#{var(--loader-size)} / 30));
    }

    ::v-deep .loader-border {
      border-width: 1px;

      &::before,
      &::after {
        border-width: 1px;
      }
    }
  }

  .cancel-button {
    cursor: pointer;
    pointer-events: auto;

    &:hover {
      color: $color-error;
    }
  }

  .modal-description {
    @include font-mixin(16px, 20px, 400, $color-text-base);

    &:not(:last-child) {
      margin-bottom: 20px;
    }
  }

  .table {
    border: 1px solid $lavender;
  }

  .offer-heading {
    @include font-mixin(28px, 36px, 500, $style-white, 0);

    background: url('~@/assets/images/gruzi_bg.png') center no-repeat;
    background-size: cover;
    padding: 40px 30px 40px 50px;
    margin: -40px -40px 16px;
  }

  .offer-features {
    display: grid;
    grid-auto-flow: column;
    grid-column-gap: 20px;

    &__list {
      display: grid;
      grid-row-gap: 20px;
      grid-auto-rows: min-content;
    }
  }

  .offer-feature {
    @include font-mixin(16px, 19px, 400, $color-text-base);

    display: grid;
    grid-auto-flow: column;
    grid-column-gap: 20px;
    grid-template-columns: min-content 1fr;
    align-items: flex-start;
    padding: 10px;

    &__icon {
      background-color: $Green-700;
      color: $style-white;
      border-radius: 8px;
      font-size: 24px;
      width: 36px;
      height: 36px;
      display: flex;
      align-items: center;
      justify-content: center;
    }

    &__text {
      max-width: 204px;

      &.short-block {
        max-width: 165px;
      }
    }
  }

  ::v-deep .text-gray {
    color: $color-grey-span;
  }
</style>